Function pbsKeywordGetFileList Alias "pbsKeywordGetFileList"() Export As String
	Local sb As IStringBuilderA
	Local filename As String
	Local p As Long

	If Not init_ Then Call Initialize()

	sb = Class "StringBuilderA"
	filename = Dir$( "config\*.builtin" )
	While filename<>""
		p = InStr( -1, filename, "." )
		' PathScan doesn't work because file has to exist, we'd have to build the full path
		If p>0 Then filename = Left$( filename, p-1 )
		If sb.Len Then sb.Add( $CrLf )
		sb.add( filename )
		filename = Dir$
	Wend
	Function = sb.String
End Function

Sub pbsKeywordLoad Alias "pbsKeywordLoad"( keywordName As String ) Export
	Local filename As String

	If Not init_ Then Call Initialize()

	filename = Exe.Path$ + "config\" + keywordName + ".builtin"
	If IsFile( filename ) Then
		keywords_ = Nothing
		Call NewStringBagFromFile( keywords_, filename )
		keywordFile = keywordName
		If IsInterface( tokenizer_, iLineTokenizer ) Then
			tokenizer_.Keywords = keywords_
		End If
	End If
End Sub

Function pbsKeywordGetFilename Alias "pbsKeywordGetFilename"() Export As String
	If Not init_ Then Call Initialize()
	Function = keywordFile
End Function

Function pbsKeywordExists Alias "pbsKeywordExists"( value As String ) Export As Long
	If Not init_ Then Call Initialize()
	Function = keywords_.Contains( value )
End Function

Function pbsKeywordStandardize Alias "pbsKeywordStandardize"( value As String ) Export As String
	If Not init_ Then Call Initialize()
	If keywords_.Contains( value ) Then
		Function = keywords_.Item( value )
	End If
End Function

Function pbsKeywordGetKeywords Alias "pbsKeywordGetKeywords"( keywordName As String ) Export As String
	Local filename, keywords As String
	Local f As Long

	If Not init_ Then Call Initialize()

	filename = Exe.Path$ + "config\" + keywordName + ".builtin"
	If IsFile( filename ) Then
		f = FreeFile
		Open filename For Binary As #f
		Get$ #f, Lof(#f), keywords
		Close #f
		Function = keywords
	End If
End Function

Sub pbsKeywordSaveKeywords Alias "pbsKeywordSaveKeywords"( keywordName As String, keywords As String ) Export
	Local filename As String
	Local f As Long

	If Not init_ Then Call Initialize()

	filename = Exe.Path$ + "config\" + keywordName + ".builtin"
	Call EnsureFileAndPath( filename )
	f = FreeFile
	Open filename For Output As #f
	Print #f, keywords;
	Close #f
End Sub
