Function sfToHtml( sf As iSourceFile, title As String, ByVal tabSize As Long, ByVal keywordCasing As Long, ByVal singleCaseIdentifier As Long, ByVal includeMonoFormat As Long, ByVal includeColorFormat As Long  ) As String
	Local sb As IStringBuilderA
	Local bLine As IStringBuilderA

	Local v() As String
	Local i, j, c, c1, e As Long
	Local value, v2 As String
	Local identifiers As iStringBag
	Local token As StringZ Ptr
	Local vCol As Long
	Local vType As Long
	Local isKeyword As Long
	Local d, lastType, nextType As Long
	Local a, b As StringZ Ptr
	Local lastKey, nextKey As Long

	If Not init_ Then Call Initialize()

	sb = Class "StringBuilderA"
	bLine = Class "StringBuilderA"
	If singleCaseIdentifier Then Call NewStringBag( identifiers, 50000 )


										sb.Add("<br/>"): sb.Add( $CrLf )
	sb.Add( title ):  sb.Add("<br/>"): sb.Add( $CrLf )
	sb.Add( "<code><pre>" )

	For i=0 To sf.Count-1
		value = sf.Line(i)
		value = ExpandTabs( value, tabSize )

		If keywordCasing<>%KeywordCase.Original Or singleCaseIdentifier Or includeMonoFormat Or includeColorFormat Then
			tokenizer_.SetLine( value )
			bLine.Clear
			c1 = tokenizer_.Count-1
			e = 0
			For j = 0 To c1
				If j Then tokenizer_.GetToken( j-1, a, d, lastType ) Else lastType = -1
				If j<c1 Then tokenizer_.GetToken( j+1, b, d, nextType ) Else nextType = -1
				tokenizer_.GetToken( j, token, vCol, vType )
				While vCol+e > bLine.Len
					bLine.Add(" ")
				Wend
				value = @token
				e -= Len( value )
				Select Case Const vType
					Case %TokenTypes.eAsm
			If includeColorFormat And lastType<>vType Then sbAdd( bLine, "<span style=""color:#c00000"">", e )
						sbAdd( bLine, value, e )
						If includeColorFormat And vType<>nextType Then sbAdd( bLine, "</span>", e )
					Case %TokenTypes.eContinue, %TokenTypes.eNumber
						sbAdd( bLine, value, e )
					Case %TokenTypes.eIdentifier, %TokenTypes.eKeyword, %TokenTypes.eConstant
						isKeyword = keywords_.Contains( value )
						If isKeyword Then
							If lastType>-1 Then lastKey = keywords_.Contains( ByCopy @a ) Else lastKey = 0
							If nextType>-1 Then nextKey = keywords_.Contains( ByCopy @b ) Else nextKey = 0
						End If
						If isKeyword And includeMonoFormat And (lastType<>vType Or IsFalse lastKey ) Then sbAdd( bLine, "<b>", e )
						If isKeyword And includeColorFormat And (lastType<>vType Or IsFalse lastKey ) Then sbAdd( bLine, "<span style=""color:#0000c0"">", e )
						If isKeyword Then
							Select Case Const keywordCasing
								'Case %KeywordCase.Original: ' Nothing
								Case %KeywordCase.Upper:    value = UCase$( value )
								Case %KeywordCase.Lower:    value = LCase$( value )
								Case %KeywordCase.Mixed:    value = keywords_.Item( value )
							End Select
						ElseIf singleCaseIdentifier Then
							If Not identifiers.Contains( value ) Then identifiers.Add( value )
							value = identifiers.Item( value )
						End If
						sbAdd( bLine, value, e )
						If isKeyword And includeColorFormat And (vType<>nextType Or IsFalse nextKey ) Then sbAdd( bLine, "</span>", e )
						If isKeyword And includeMonoFormat And (vType<>nextType Or IsFalse nextKey ) Then sbAdd( bLine, "</b>", e )
					Case %TokenTypes.eString
						If includeColorFormat And lastType<>vType Then sbAdd( bLine, "<span style=""color:#c020c0"">", e )
						sbAdd( bLine, value, e )
						If includeColorFormat And vType<>nextType Then sbAdd( bLine, "</span>", e )
					Case %TokenTypes.eOperator
						If includeColorFormat And lastType<>vType Then sbAdd( bLine, "<span style=""color:#8000ff"">", e )
						sbAdd( bLine, value, e )
						If includeColorFormat And vType<>nextType Then sbAdd( bLine, "</span>", e )
					Case %TokenTypes.eRemark
						If includeMonoFormat And lastType<>vType Then sbAdd( bLine, "<i>", e )
						If includeColorFormat And lastType<>vType Then sbAdd( bLine, "<span style=""color:#007f00"">", e )
						sbAdd( bLine, value, e )
						If includeColorFormat And vType<>nextType Then sbAdd( bLine, "</span>", e )
						If includeMonoFormat And vType<>nextType Then sbAdd( bLine, "</i>", e )
				End Select
			Next
			value = bLine.String
			sb.Add( value )
			sb.Add( $CrLf )
		End If
	Next
	sb.Add( "</pre></code>" )
	sb.Add("<br/>")
	sb.Add( $CrLf )
	Function = sb.String
End Function

Function FileToHtml( sf As iSourceFile, ByVal tabSize As Long, ByVal keywordCasing As Long, ByVal singleCaseIdentifier As Long, ByVal includeMonoFormat As Long, ByVal includeColorFormat As Long ) As String
	Local fileName As String

	If IsFalse IsInterface( sf, iSourceFile ) Then Exit Function
	filename = sf.Filename
	pbsFileShortname( filename )

	filename = Build$( "File: <b>", filename, "</b>" )

	Function = sfToHtml( sf, filename, tabSize, keywordCasing, singleCaseIdentifier, includeMonoFormat, includeColorFormat )
End Function

Function ProjectToHtml( ByVal tabSize As Long, ByVal keywordCasing As Long, ByVal singleCaseIdentifier As Long, ByVal includeMonoFormat As Long, ByVal includeColorFormat As Long ) As String
	Local sb As IStringBuilderA
	Local i As Long
	Local value As String
	Local sf As iSourceFile

	sb = Class "StringBuilderA"

	For i=0 To project_.Count-1
		If IsFalse project_.Value( i ).IsExternal Then
			sf = project_.Value(i)
			sb.Add( FileToHtml( sf, tabSize, keywordCasing, singleCaseIdentifier, includeMonoFormat, includeColorFormat ) )
		End If
	Next
	Function = sb.String
End Function
