Sub NewIndent( obj As iIndent )
	obj = Class "cIndent"
End Sub

Class cIndent
	Instance sf_ As iSourceFile
	Instance row_, tkn_ As Long: ' Location
	Instance tokenCount_ As Long: ' Token count
	Instance startRow_, starttkn_ As Long

	Interface iIndent
		Inherit IUnknown
		Method Indent( sf As iSourceFile, Optional ByVal isDefinition As Long )
			#Debug Code On
			Local statementEnd As String: ' If block statement ends on line, what is the ending word?  Do While i<5: Incr i: Loop
			Local p As Byte Ptr
			Local sp As StringZ Ptr
			Local r, i, c, tknTyp, ln, t2, j, c2 As Long
			Local beforeIndent, currentIndent, afterIndent As Long
			Local inClass, preContinue, inEnd, isLabel, isDirective, inType, statementEndWordCount, lastContinued As Long
			Local value As String

			If isDefinition Then inClass = -1

			sf_ = sf
			row_ = 0
			tkn_ = 0

			For r=0 To sf.Count-1
				beforeIndent = 0
				afterIndent = 0
				row_ = r
				tkn_ = 0
				tokenizer_.SetLinePointer( sf.LinePointer( r ) )
				tokenCount_ = tokenizer_.Count
				If tokenCount_=0 Then Iterate For: ' Nothing here to play with
				tokenizer_.GetToken( 0, p, c, tknTyp )

				value = sf.Line(r)

				sp = p
				isDirective = (@p=%cHash)
				statementEnd = @sp
				Call ToLowerA( statementEnd )
				statementEndWordCount = 2

				If tknTyp = %TokenTypes.eIdentifier And tokenCount_>1 Then
					tokenizer_.GetToken( 1, p, c, tknTyp )
					isLabel = ( @p = %cColon )
					If isLabel And tokenCount_>2 Then
						For j = 2 To tokenCount_-1
							tokenizer_.GetToken( 2, p, c, tknTyp )
							If p<>%cColon Then Exit For
						Next
						isLabel = (tknTyp = %TokenTypes.eRemark)
					End If
					tokenizer_.GetToken( 0, p, c, tknTyp )
				End If

				Select Case Const$ statementEnd
					Case "_"
						If Not lastContinued Then
							statementEnd = ""
							beforeIndent += 1
							lastContinued = -1
							preContinue = -1
						End If
						' Ending matches begining
					Case "fastproc", "interface", "sub", "try", "prefix", "asmdata"
						If (lastContinued And Not preContinue) Or inEnd Or inType Then statementEnd="": Exit Select
						preContinue = 0
						afterIndent = 1

					Case "enum", "union"
						If (lastContinued And Not preContinue) Or inEnd Or inType Then statementEnd="": Exit Select
						afterIndent += 1
						preContinue = 0
						inType = -1

					Case "type"
						If (lastContinued And Not preContinue) Or inEnd Or inType Then statementEnd="": Exit Select
						preContinue = 0
						If Not Me.NextStatementToken( p, c, tknTyp ) Then Iterate For
						sp = p
						If PtrStrICmp( p, "set" ) = 0 Then
							statementEnd = ""
						Else
							afterIndent += 1
							inType = -1
						End If

					Case "select"
						If (lastContinued And Not preContinue) Or inEnd Or inType Then statementEnd="": Exit Select
						preContinue = 0
						afterIndent += 2

					Case "class"
						If (lastContinued And Not preContinue) Or inEnd Or inType Then statementEnd="": Exit Select
						' Class or Class Method, both indent, both indicate we must be in a class
						preContinue = 0
						afterIndent += 1
						inClass = -1

					Case "if"
						If (lastContinued And Not preContinue) Or inEnd Or inType Then statementEnd="": Exit Select
						preContinue = 0
						afterIndent += 1
						While Me.NextStatementToken( p, c, tknTyp )
							sp = p
							j = PtrStrICmp( p, "then" )
							If j=0 Then
								Exit Loop
							ElseIf PtrStrICmp( p, "goto" )=0 Then
								statementEnd=""
								afterIndent -= 1
								Exit Select
							End If
						Wend

						If afterIndent And Me.NextStatementToken( p, c, tknTyp ) Then
							sp = p
							While @p = %cColon And Me.NextStatementToken( p, c, tknTyp )
								sp = p
							Wend
							If tknTyp <> %TokenTypes.eRemark Then
								statementEnd = ""
								afterIndent -= 1
							End If
						End If

					Case "macro"
						If (lastContinued And Not preContinue) Or inEnd Or inType Then statementEnd="": Exit Select
						preContinue = 0
						afterIndent += 1
						While Me.NextStatementToken( p, c, tknTyp )
							sp = p
							If @p = %cEqual Then afterIndent -= 1: Exit Loop
						Wend

					Case "property", "method", "override"
						If (lastContinued And Not preContinue) Or inEnd Or inType Then statementEnd="": Exit Select
						preContinue = 0
						If inClass Then
							If Not Me.NextStatementToken( p, c, tknTyp ) Then Iterate For
							If @p <> %cEqual And PtrStrICmp( p, "objresult")<>0 Then afterIndent += 1
						End If

					Case "function"
						If (lastContinued And Not preContinue) Or inEnd Or inType Then statementEnd="": Exit Select
						preContinue = 0
						If Not Me.NextStatementToken( p, c, tknTyp ) Then Iterate For
						If @p <> %cEqual Then afterIndent += 1

						' Special statementEndWordCount
					Case "callback", "thread"
						If (lastContinued And Not preContinue) Or inEnd Or inType Then statementEnd="": Exit Select
						preContinue = 0
						If Not Me.NextStatementToken( p, c, tknTyp ) Then Iterate For
						If PtrStrICmp( p, "function" )=0 Then
							statementEnd = "function"
							afterIndent += 1
						ElseIf PtrStrICmp( p, "method" ) Then
							statementEnd = "method"
							afterIndent += 1
						End If

					Case "do":
						If (lastContinued And Not preContinue) Or inEnd Or inType Then statementEnd="": Exit Select
						preContinue = 0
						statementEnd = "loop"
						afterIndent += 1
						statementEndWordCount = 1

					Case "for":
						If (lastContinued And Not preContinue) Or inEnd Or inType Then statementEnd="": Exit Select
						preContinue = 0
						statementEnd = "next"
						afterIndent += 1
						statementEndWordCount = 1

					Case "override":
						If (lastContinued And Not preContinue) Or inEnd Or inType Then statementEnd="": Exit Select
						preContinue = 0
						statementEnd = "method"
						afterIndent += 1

					Case "while":
						If (lastContinued And Not preContinue) Or inEnd Or inType Then statementEnd="": Exit Select
						preContinue = 0
						statementEnd = "wend"
						afterIndent += 1
						statementEndWordCount = 1

						' Outdent, then indent
					Case "catch", "else", "elseif", "finally", "case"
						If (lastContinued And Not preContinue) Or inEnd Or inType Then statementEnd="": Exit Select
						preContinue = 0
						statementEnd = ""
						beforeIndent -= 1
						afterIndent += 1

						' endings
					Case "end"
						preContinue = 0
						If Me.NextStatementToken( p, c, tknTyp ) Then
							sp = p
							If @p<>%cEqual And @p<>%cColon Then
								inEnd = -1
								inType = 0
								statementEnd = ""
								If lastContinued Then afterIndent -= 1 Else beforeIndent -= 1
								Select Case LCase$( @sp )
									Case "select": beforeIndent -= 1
									Case "class": inClass = 0
								End Select
							End If
						End If

					Case "loop", "next", "wend"
						If (lastContinued And Not preContinue) Or inEnd Or inType Then statementEnd="": Exit Select
						preContinue = 0
						statementEnd = ""
						beforeIndent -= 1

					Case Else:
						' No indent change
						preContinue = 0
						statementEnd = ""
				End Select

				If Not lastContinued Then
					tokenizer_.SetLinePointer( sf.LinePointer( r ) )
					tokenCount_ = tokenizer_.Count
					' Check for continuation
					For i=0 To tokenCount_-1
						tokenizer_.GetToken( i, p, c, tknTyp )
						If @p=%cUnderline Then
							afterIndent += 1
							lastContinued = -1
							Exit For
						End If
					Next
				End If

				' Check for single line variation
				If afterIndent>0 And statementEnd<>"" Then
					tokenizer_.SetLinePointer( sf.LinePointer( r ) )
					tokenCount_ = tokenizer_.Count
					Do While Me.NextStatementToken( p, c, tknTyp )
						sp = p
						Select Case Const statementEndWordCount
							Case 1:
								If PtrStrICmp( p, statementEnd ) = 0 Then afterIndent -= 1: Exit Loop
							Case 2:
								If PtrStrICmp( p, "end" ) = 0 Then
									If Me.NextStatementToken( p, c, tknTyp ) Then
										If PtrStrICmp( p, statementEnd )=0 Then afterIndent -= 1: Exit Loop
										sp = p
									End If
								End If
						End Select
					Loop
				End If

				currentIndent = Max( 0, currentIndent + beforeIndent )
				value = sf.Line(r)
				If isLabel Then
					Me.IndentLine( value, 0 )
				Else
					Me.IndentLine( value, currentIndent )
				End If
				sf.Line(r) = value

				If lastContinued Then
					' Check to see if we will continue, continuing... :)
					tokenizer_.SetLinePointer( sf.LinePointer( r ) )
					tokenCount_ = tokenizer_.Count
					lastContinued = 0
					tokenizer_.SetLinePointer( sf.LinePointer( r ) )
					tokenCount_ = tokenizer_.Count
					For i=0 To tokenCount_-1
						tokenizer_.GetToken( i, p, c, tknTyp )
						If @p=%cUnderline Then lastContinued = -1: Exit For
					Next
					If Not lastContinued Then afterIndent -= 1: inEnd = 0
				Else
					inEnd = 0
				End If
				currentIndent = Max( 0, currentIndent+afterIndent )
			Next
			sf_ = Nothing
		End Method
	End Interface

	Class Method IndentLine( value As String, ByVal indent As Long )
		Local bp As Byte Ptr
		Register i As Long

		bp = StrPtr( value )
		While @bp[i]=%cSpace Or @bp[i]=%cTab
			Incr i
		Wend
		value = Repeat$( indent, $Tab ) +  Mid$( value, i+1 )
	End Method

	Class Method NextStatementToken( t As Dword, cl As Long, tknTyp As Long) As Long
		Local bp As Byte Ptr

		Incr tkn_
		If tkn_ >= tokenCount_ Then Exit Method
		tokenizer_.GetToken( tkn_, bp, cl, tknTyp )
		If @bp=%cUnderline Then tkn_ = 0
		While @bp=%cUnderline
			Incr row_
			If row_ >= sf_.Count Then Exit Method
			tokenizer_.SetLinePointer( sf_.LinePointer( row_ ) )
			tokenCount_ = tokenizer_.Count
			tokenizer_.GetToken( 0, bp, cl, tknTyp )
		Wend
		t = bp
		Method = -1
	End Method
End Class
