Sub ProjectTests()
	Local paths As String
	Local filename As String
	Local value, value2 As String
	Local decl As TDecl
	Local i, c, isExternal As Long

	pbsKeywordLoad( "pbwin10" )
	tokenizer_.Keywords = keywords_
	Debug_SetGroup("Project")
	Debug_Log("")
	Debug_Log("============================================")
	Debug_Log("Project")
	Debug_Log("--------------------------------------------")
	Shell( "cmd /c " + RemoveDirectory( "TestProject2" ), 0 )
	Shell( "cmd /c " + RemoveDirectory( "TestProject3" ), 0 )

	' ===========================================================================
	' TEST: Project tests
	' ===========================================================================
	' Should drop c:\invalidDirectory and blank directory at end

	'=================================================================
	Call pbsProjectSetIncludePaths( " c:\pbwin10\winapi ; c:\pbwin10\winapi_iii ; c:\invalidDirectory;"+$BASE_PATH+"TestProject;" )
	Call pbsProjectGetIncludePaths( paths )
	Call pbsProjectLoad( basePath + "testproject\test.bas" )
	c = pbsProjectFileCount()
	Debug_IsEqual(   1, paths, "c:\pbwin10\winapi\;c:\pbwin10\winapi_iii\;"+$BASE_PATH+"TestProject\", "Path" )
	Debug_IsEqual(   2, c, 7, "ProjectFileCount")

	'=================================================================
	' Test if project has file
	isExternal = pbsProjectHasFile( "OLE.INC" )
	Debug_IsTrue(   3, isExternal, "{c:\pbwin10\winapi\ole.inc} is not in project." )

	isExternal = pbsProjectHasFile( "test.bas" )
	Debug_IsTrue(   4, isExternal, "{" +basepath + "testproject\test.bas} is not in project." )

	isExternal = pbsProjectHasFile( "test1.inc" )
	Debug_IsTrue(   5, isExternal, "{" +basepath + "testproject\test1.inc} is not in project." )

	isExternal = pbsProjectHasFile( "test2.inc" )
	Debug_IsTrue(   6, isExternal, "{" +basepath + "testproject\test2.inc} is not in project." )

	isExternal = pbsProjectHasFile( "test3.inc" )
	Debug_IsTrue(   7, isExternal, "{" +basepath + "testproject\test3.inc} is not in project." )

	isExternal = pbsProjectHasFile( "test4.inc" )
	Debug_IsTrue(   8, isExternal, "{" +basepath + "testproject\test4.inc} is not in project." )

	isExternal = pbsProjectHasFile( "sub\test5.bas" )
	Debug_IsTrue(   9, isExternal, "{" +basepath + "testproject\sub\test5.bas} is not in project." )


	'=================================================================
	' Check that files are external or not
	isExternal = pbsFilenameIsExternal( "C:\PBWIN10\WINAPI\OLE.INC" )
	Debug_IsTrue(  10, isExternal, "{c:\pbwin10\winapi\ole.inc} is not external" )

	isExternal = pbsFileNameIsExternal( basepath + "testproject\test.bas" )
	Debug_IsFalse(  11, isExternal, "{" +basepath + "testproject\test.bas} is external" )

	isExternal = pbsFileNameIsExternal( basepath + "testproject\test1.inc" )
	Debug_IsFalse(  12, isExternal, "{" +basepath + "testproject\test1.inc} is external" )

	isExternal = pbsFileNameIsExternal( basepath + "testproject\test2.inc" )
	Debug_IsFalse(  13, isExternal, "{" +basepath + "testproject\test2.inc} is external" )

	isExternal = pbsFileNameIsExternal( basepath + "testproject\test3.inc" )
	Debug_IsFalse(  14, isExternal, "{" +basepath + "testproject\test3.inc} is external" )

	isExternal = pbsFileNameIsExternal( basepath + "testproject\test4.inc" )
	Debug_IsFalse(  15, isExternal, "{" +basepath + "testproject\test4.inc} is external" )

	isExternal = pbsFileNameIsExternal( basepath + "testproject\sub\test5.bas" )
	Debug_IsFalse(  16, isExternal, "{" +basepath + "testproject\sub\test5.bas} is external" )

	'=================================================================
	pbsProjectClose()
	c = pbsProjectFileCount()
	Debug_IsEqual(  17, c, 0, "ProjectFileCount" )

	Debug_IsEqual(  18, debug_activeInstances, 7, "ActiveClassInstances" )

	'=================================================================
	Call pbsProjectLoad( basePath + "testproject\test.bas" )
	c = pbsProjectFileCount()
	Debug_IsEqual(  19, c, 7, "ProjectFileCount" )

	'=================================================================
	' Save project to new location
	Call pbsProjectSetBasePath( basePath + "TestProject2" )
	Call pbsProjectSave()
	Call pbsProjectGetBasePath( paths )
	Debug_IsEqual(  20, LCase$(paths), LCase$(basePath+"TestProject2\"), "BasePath" )

	'=================================================================
	Call pbsProjectNew( basePath + "TestProject3\test.bas" )
	Call pbsProjectSave()
	Debug_IsTrue(  21, IsFile( basePath + "TestProject3\test.bas"), basePath + "TestProject3\test.bas was not created." )

	'=================================================================
	value = pbsProjectGetFilename( 0 )
	Debug_IsEqual(  22, LCase$( value ), LCase$( basePath + "TestProject3\test.bas" ), "FileName" )


	'=================================================================
	pbsProjectClose()
	Call pbsProjectLoad( basePath + "testproject\testformat.bas" )
	Debug_IsEqual(  23, pbsProjectByteCount(), 612, "ByteCount" )

	'=================================================================
	pbsProjectClose()
	Call pbsProjectLoad( basePath + "testproject\test.bas" )
	Debug_IsEqual(  24, pbsProjectFileCount(), 7, "CloseFile" )

	pbsProjectCloseFile( 6 )
	Debug_IsEqual(  25, pbsProjectFileCount(), 6, "CloseFile" )

	pbsProjectCloseFile( 5 )
	Debug_IsEqual(  26, pbsProjectFileCount(), 5, "CloseFile" )

	pbsProjectCloseFile( 4 )
	Debug_IsEqual(  27, pbsProjectFileCount(), 4, "CloseFile" )

	pbsProjectCloseFile( 3 )
	Debug_IsEqual(  28, pbsProjectFileCount(), 3, "CloseFile" )

	pbsProjectCloseFile( 2 )
	Debug_IsEqual(  29, pbsProjectFileCount(), 2, "CloseFile" )

	pbsProjectCloseFile( 1 )
	Debug_IsEqual(  30, pbsProjectFileCount(), 1, "CloseFile" )

	pbsProjectCloseFile( 0 )
	Debug_IsEqual(  31, pbsProjectFileCount(), 0, "CloseFile" )

	'=================================================================
	pbsProjectClose()
	Call pbsProjectLoad( basePath + "testproject\testindent.bas" )
	pbsProjectRemoveContinuation()
	pbsProjectTrimWhitespace()
	pbsProjectIndent()
	pbsProjectManageBlankLines()
	'Call pbsProjectSetFilename( 0, basePath + "testproject\testIndentManaged2.bas" )
	'pbsProjectSave()
	pbsFileActivate( 0 )
	value = pbsFileGetText()
	pbsFileLoad( basePath + "testproject\testIndentManaged.bas" )
	Debug_IsEqual(  32, value, pbsFileGetText(), "Manage" )

	'=================================================================
	pbsProjectClose()
	Call pbsProjectLoad( basePath + "testproject\test.bas" )
	Debug_IsEqual(  33, pbsProjectGetFileNumber( "test.bas" ), 0, "GetFilenumber" )
	Debug_IsEqual(  34, pbsProjectGetFileNumber( basePath + "testProject\test.bas"), 0, "GetFilenumber" )
	Debug_IsEqual(  35, pbsProjectGetFilename( 0 ), basePath + "testproject\test.bas", "GetFilename" )

	'=================================================================
	pbsProjectClose()
	pbsProjectSetTabsize( 4 )
	Debug_IsEqual(  36, pbsProjectGetTabSize(), 4, "TabSize" )
	pbsProjectSetTabsize( 2 )
	Debug_IsEqual(  37, pbsProjectGetTabSize(), 2, "TabSize" )
	pbsProjectSetTabsize( 1 )
	Debug_IsEqual(  38, pbsProjectGetTabSize(), 1, "TabSize" )
	pbsProjectSetTabsize( 0 )
	Debug_IsEqual(  39, pbsProjectGetTabSize(), 0, "TabSize" )
	pbsProjectSetTabsize( -1 )
	Debug_IsEqual(  40, pbsProjectGetTabSize(), 0, "TabSize" )
	pbsProjectSetTabsize( 2 )
	pbsProjectSetTabsize( -1 )
	Debug_IsEqual(  41, pbsProjectGetTabSize(), 2, "TabSize" )

	'=================================================================
	pbsProjectClose()
	Call pbsProjectLoad( basePath + "testproject\test.bas" )
	Debug_IsEqual(  42, pbsProjectHasFile( "test.bas" ), -1, "HasFile" )
	Debug_IsEqual(  43, pbsProjectHasFile( basePath + "testproject\test.bas" ), -1, "HasFile" )
	Debug_IsEqual(  44, pbsProjectHasFile( "testindent.bas" ), 0, "HasFile" )
	Debug_IsEqual(  45, pbsProjectHasFile( basePath + "testproject\testindent.bas" ), 0, "HasFile" )

	'=================================================================
	pbsProjectClose()
	Call pbsProjectLoad( basePath + "testproject\testcount.bas" )
	Debug_IsEqual(  46, pbsProjectLineCount(), 7, "LineCount" )
	Debug_IsEqual(  47, pbsProjectByteCount(), 125, "ByteCount" )

	'=================================================================
	pbsProjectClose()
	Call pbsProjectLoad( basePath + "testproject\testindent.bas" )
	pbsProjectDeclareScan()
	pbsProjectAddDebugAliases()
	'Call pbsProjectSetBasePath( basePath + "TestProject3" )
	'pbsProjectSave()
	pbsFileActivate( 0 )
	value = pbsFileGetText()
	pbsSnippetNew("test")
	pbsSnippetLoad( basePath + "testProject\testindentDebugAlias.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual(  48, value, value2, "DebugAlias" )

	'=================================================================
	pbsProjectClose()
	Call pbsProjectLoad( basePath + "testproject\testindent.bas" )
	pbsProjectDeclareScan()
	pbsProjectAddDebugAliases()
	pbsProjectRemoveAliases()
'  Call pbsProjectSetBasePath( basePath + "TestProject3" )
'  pbsProjectSave()
	pbsFileActivate( 0 )
	value = pbsFileGetText()
	pbsSnippetNew("test")
	pbsSnippetLoad( basePath + "testProject\testindent.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual(  49, value, value2, "RemoveAlias" )

	'=================================================================
	pbsProjectClose()
	Call pbsProjectLoad( basePath + "testproject\testindent.bas" )
	pbsProjectDeclareScan()
	value = pbsProjectFindExports()
	pbsProjectStandardizeExportAliases(value)
'  Call pbsProjectSetBasePath( basePath + "TestProject3" )
'  pbsProjectSave()
	pbsFileActivate( 0 )
	value = pbsFileGetText()
	pbsSnippetNew("test")
	pbsSnippetLoad( basePath + "testProject\testindentStdAlias.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual(  50, value, value2, "StandardizeExportAlias" )


	'=================================================================
	pbsProjectClose()
	pbsFileNew( basePath + "TestProject3\a.inc", -1 )
	pbsFileSetText( Build$( $Tab, $Tab, "Test" ) )
	pbsFileNew( basePath + "TestProject3\b.inc", -1 )
	pbsFileSetText( Build$( $Tab, $Tab, "Test2" ) )
	pbsProjectSetTabSize( 0 )
	pbsProjectExpandTabs( 0 )
	value = pbsFileGetText()
	Debug_IsEqual(  51, value, Build$( $Tab, $Tab, "Test2" ), "ExpandTabs" )
	pbsFileActivate(0)
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  52, value, Build$( $Tab, $Tab, "Test" ), "ExpandTabs" )

	'=================================================================
	pbsProjectClose()
	pbsFileNew( basePath + "TestProject3\a.inc", -1 )
	pbsFileSetText( Build$( $Tab, $Tab, "Test" ) )
	pbsFileNew( basePath + "TestProject3\b.inc", -1 )
	pbsFileSetText( Build$( $Tab, $Tab, "Test2" ) )
	pbsProjectSetTabSize( 0 )
	pbsProjectExpandTabs( 1 )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  53, value, Build$( "  Test2" ), "ExpandTabs" )
	pbsFileActivate(0)
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  54, value, Build$( "  Test" ), "ExpandTabs" )

	'=================================================================
	pbsProjectClose()
	pbsFileNew( basePath + "TestProject3\a.inc", -1 )
	pbsFileSetText( Build$( $Tab, $Tab, "Test" ) )
	pbsFileNew( basePath + "TestProject3\b.inc", -1 )
	pbsFileSetText( Build$( $Tab, $Tab, "Test2" ) )
	pbsProjectSetTabSize( 0 )
	pbsProjectExpandTabs( 2 )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  55, value, Build$( "    Test2" ), "ExpandTabs" )
	pbsFileActivate(0)
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  56, value, Build$( "    Test" ), "ExpandTabs" )

	'=================================================================
	pbsProjectClose()
	pbsFileNew( basePath + "TestProject3\a.inc", -1 )
	pbsFileSetText( Build$( $Tab, $Tab, "Test" ) )
	pbsFileNew( basePath + "TestProject3\b.inc", -1 )
	pbsFileSetText( Build$( $Tab, $Tab, "Test2" ) )
	pbsProjectSetTabSize( 0 )
	pbsProjectExpandTabs( 3 )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  57, value, Build$( "      Test2" ), "ExpandTabs" )
	pbsFileActivate(0)
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  58, value, Build$( "      Test" ), "ExpandTabs" )


	'=================================================================
	pbsProjectClose()
	pbsFileNew( basePath + "TestProject3\a.inc", -1 )
	pbsFileSetText( "#include ""b.inc""" )
	pbsFileNew( basePath + "TestProject3\b.inc", -1 )
	pbsFileSetText( Build$( $Tab, $Tab, "Test2" ) )
	pbsProjectSave()
	pbsFileActivate(0)
	pbsFileSetText("")
	pbsFileActivate(1)
	pbsFileSetText("")
	pbsProjectReload()
	pbsFileActivate(0)
	value =pbsFileGetText()
	Debug_IsEqual(  59, value, "#include ""b.inc""", "Reload" )
	pbsFileActivate(1)
	value = pbsFileGetText()
	Debug_IsEqual(  60, value,Build$( $Tab, $Tab, "Test2" ), "Reload" )

	'=================================================================
	pbsProjectClose()
	pbsProjectLoad( basePath + "TestProject\ExportCommon.bas" )
	pbsProjectDeclareScan()
	value = pbsProjectBuildDLLInclude()
'  pbsSnippetNew("test")
'  pbsSnippetSetText( value )
'  pbsSnippetSetFilename( basePath + "TestProject3\ExportCommonDLL.bas" )
'  pbsSnippetSave()
	pbsSnippetNew("test")
	pbsSnippetLoad( basePath + "testProject\ExportcommonDLL.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual(  61, value, value2, "BuildDLL" )

	'=================================================================
	pbsProjectClose()
	pbsProjectLoad( basePath + "TestProject\ExportCommon.bas" )
	pbsProjectDeclareScan()
	value = pbsProjectBuildSLLInclude()
'  pbsSnippetNew("test")
'  pbsSnippetSetText( value )
'  pbsSnippetSetFilename( basePath + "TestProject3\ExportCommonSLL.bas" )
'  pbsSnippetSave()
	pbsSnippetNew("test")
	pbsSnippetLoad( basePath + "testProject\ExportcommonSLL.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual(  62, value, value2, "BuildSLL" )


	'=================================================================
	pbsProjectClose()
	pbsFileNew( basePath + "TestProject3\c.inc", -1 )
	pbsFileSetText( Build$( "#Compile Exe", $CrLf, "#Include ""b.inc""", $CrLf, "%ONE=1", $CrLf ) )

	pbsFileNew( basePath + "TestProject3\d.inc", -1 )
	pbsFileSetText( Build$( "' Test routine", $CrLf, "Sub Test()", $CrLf, $Tab, "? ""Hello"" + Str$(%one)", $CrLf, "End Sub" ) )
	pbsProjectSave()
	'                                                  single
	'                        tab  Keyword casing         case  mono color
	value = pbsProjectToHtml(  2, %KeywordCase.Original,   -1,   -1,   -1 )
'  pbsSnippetNew("test")
'  pbsSnippetSetText( value )
'  pbsSnippetSetFilename( basePath + "TestProject3\c.html" )
'  pbsSnippetSave()
	pbsSnippetNew("test")
	pbsSnippetLoad( basePath + "testProject\c.html" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual(  63, value, value2, "ToHtml" )

	'=================================================================
	pbsProjectClose()
	pbsFileNew( basePath + "TestProject3\c.inc", -1 )
	pbsFileSetText( Build$( "#Compile Exe", $CrLf, "#Include ""b.inc""", $CrLf, "%ONE=1", $CrLf ) )

	pbsFileNew( basePath + "TestProject3\d.inc", -1 )
	pbsFileSetText( Build$( "' Test routine", $CrLf, "Sub Test()", $CrLf, $Tab, "? ""Hello"" + Str$(%one)", $CrLf, "End Sub" ) )
	pbsProjectSave()
	'                                                     single
	'                          tab  Keyword casing         case  mono color
	value = pbsProjectToBBCode(  2, %KeywordCase.Original,   -1,   -1,   -1 )
'  pbsSnippetNew("test")
'  pbsSnippetSetText( value )
'  pbsSnippetSetFilename( basePath + "TestProject3\c.bbcode" )
'  pbsSnippetSave()
	pbsSnippetNew("test")
	pbsSnippetLoad( basePath + "testProject\c.bbcode" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual(  64, value, value2, "ToBBCode" )

	'=================================================================
	pbsProjectClose()
	pbsFileNew( basePath + "TestProject3\c.inc", -1 )
	pbsFileSetText( Build$( "#Compile Exe", $CrLf, "#Include ""b.inc""", $CrLf, "%ONE=1", $CrLf ) )

	pbsFileNew( basePath + "TestProject3\d.inc", -1 )
	pbsFileSetText( Build$( "' Test routine", $CrLf, "Sub Test()", $CrLf, $Tab, "? ""Hello"" + Str$(%one)", $CrLf, "End Sub" ) )
	pbsProjectSave()
	'                                           single
	'                    tab  Keyword casing      case
	pbsProjectToCasedText(  2, %KeywordCase.Mixed,   -1 )
'  pbsSnippetNew("test")
'  pbsFileActivate(0)
'  value = pbsFileGetText()
'  pbsSnippetSetText( value )
'  pbsSnippetSetFilename( basePath + "TestProject3\cStd.bas" )
'  pbsSnippetSave()
'  pbsFileActivate(1)
'  value = pbsFileGetText()
'  pbsSnippetSetText( value )
'  pbsSnippetSetFilename( basePath + "TestProject3\dStd.bas" )
'  pbsSnippetSave()

	pbsFileActivate(0)
	value = pbsFileGetText()
	pbsSnippetNew("test")
	pbsSnippetLoad( basePath + "testProject\cStd.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual(  65, value, value2, "ToStandard" )

	pbsFileActivate(1)
	value = pbsFileGetText()
	pbsSnippetNew("test")
	pbsSnippetLoad( basePath + "testProject\dStd.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual(  66, value, value2, "ToStandard" )

	'=================================================================
	pbsProjectClose()
	pbsFileNew( basePath + "TestProject3\e.inc", -1 )
	pbsFileSetText( Build$( "  one   ", $CrLf, $Tab, " ", $Tab, "two ",$Tab ) )

	pbsFileNew( basePath + "TestProject3\f.inc", -1 )
	pbsFileSetText( Build$( "  one2   ", $CrLf, $Tab, " ", $Tab, "two2 ",$Tab ) )

	pbsProjectTrimWhitespace()

	pbsFileActivate(0)
	value = pbsFileGetText()
	Debug_IsEqual(  67, value, Build$( "one",$CrLf,"two"), "TrimWhitespace" )
	pbsFileActivate(1)
	value = pbsFileGetText()
	Debug_IsEqual(  68, value, Build$( "one2",$CrLf,"two2"), "TrimWhitespace" )

	'=================================================================
	pbsProjectClose()
	pbsFileNew( basePath + "TestProject3\e.inc", -1 )
	pbsFileSetText( Build$( "  one   ", $CrLf, $Tab, " ", $Tab, "two ",$Tab, "one" ) )

	pbsFileNew( basePath + "TestProject3\f.inc", -1 )
	pbsFileSetText( Build$( "  one2   ", $CrLf, $Tab, " ", $Tab, "two2 ",$Tab, "one" ) )

	pbsProjectReplaceToken( "one", "ONE" )

	pbsFileActivate(0)
	value = pbsFileGetText()
	Debug_IsEqual(  69, value, Build$( "  ONE", $CrLf, "   two  ONE" ), "ReplaceToken" )
	pbsFileActivate(1)
	value = pbsFileGetText()
	Debug_IsEqual(  70, value, Build$( "  one2", $CrLf, "   two2  ONE" ), "ReplaceToken" )

	'=================================================================
	pbsProjectClose()
	pbsProjectDeclareClear()
	pbsProjectLoad( basePath + "TestProject\exportcommon.bas" )
	Debug_IsEqual(  71, pbsProjectDeclareCount(), 0, "DeclareCount" )
	pbsProjectDeclareScan()
	Debug_IsEqual(  72, pbsProjectDeclareCount(), 63, "DeclareScan" )
	pbsProjectDeclareClear()
	Debug_IsEqual(  73, pbsProjectDeclareCount(), 0, "DeclareCount" )
	pbsProjectDeclareScan()
	Debug_IsEqual(  74, pbsProjectDeclareCount(), 63, "DeclareCount" )

	'=================================================================
	pbsProjectClose()
	pbsProjectLoad( basePath + "TestProject\exportcommon.bas" )
	pbsProjectDeclareScan()
	i = pbsProjectDeclareFindName( 0, "cTest", %DeclarationTypes.eClass )
	Debug_IsTrue(  75, i>-1, "FindName" )
	i = pbsProjectDeclareFindName( 0, "iTest", %DeclarationTypes.eInterface )
	Debug_IsTrue(  76, i>-1, "FindName" )
	i = pbsProjectDeclareFindName( i+1, "iTest", %DeclarationTypes.eInterface )
	Debug_IsTrue(  77, i>-1, "FindName" )

	'=================================================================
	pbsProjectClose()
	pbsProjectLoad( basePath + "TestProject\exportcommon.bas" )
	pbsProjectDeclareScan()
	value = pbsProjectDeclareGetAllInterfaces()
	Debug_IsEqual(  78, value, Build$( "iTest", $CrLf, "iTest2", $CrLf, "iTest3" ), "GetAllInterfaces" )

	'=================================================================
	pbsProjectClose()
	pbsProjectLoad( basePath + "TestProject\exportcommon.bas" )
	pbsProjectDeclareScan()
	i = pbsProjectDeclareFindName( 0, "cTest", %DeclarationTypes.eClass )
	value = pbsProjectDeclareGetClassInterfaces( i )
	Debug_IsEqual(  79, value, Build$( "iTest", $CrLf, "iTest2", $CrLf, "iTest3" ), "GetClassInterfaces" )

	'=================================================================
	pbsProjectClose()
	pbsProjectLoad( basePath + "TestProject\exportcommon.bas" )
	pbsProjectDeclareScan()
	i = pbsProjectDeclareFindName( 0, "cTest", %DeclarationTypes.eClass )
	value = pbsProjectDeclareGetClassMethods( i )
	Debug_IsEqual(  80, value, "", "GetClassMethods" )

	'=================================================================
	pbsProjectClose()
	pbsProjectLoad( basePath + "TestProject\exportcommon.bas" )
	pbsProjectDeclareScan()
	i = pbsProjectDeclareFindName( 0, "cTest", %DeclarationTypes.eClass )
	value = pbsProjectDeclareGetClassOutline( i )
'  clipboard reset
'  clipboard set text value
	pbsSnippetNew("test")
	pbsSnippetLoad( basePath + "testProject\exportcommonoutline.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual(  81, value, value2, "GetClassOutline" )

	'=================================================================
	pbsProjectClose()
	pbsProjectLoad( basePath + "TestProject\exportcommon.bas" )
	pbsProjectDeclareScan()
	i = pbsProjectDeclareFindName( 0, "MySub4", %DeclarationTypes.eSub )
	value = pbsProjectDeclareGetDefinition( i )
'  clipboard reset
'  clipboard set text value
	pbsSnippetNew("test")
	pbsSnippetLoad( basePath + "testProject\exportcommonMySub4.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual(  82, value, value2, "GetDefinition" )

	'=================================================================
	pbsProjectClose()
	pbsProjectLoad( basePath + "TestProject\exportcommon.bas" )
	pbsProjectDeclareScan()
	i = pbsProjectDeclareFindName( 0, "cTest", %DeclarationTypes.eClass )
	value = pbsProjectDeclareGetInstanceVariables( i )
'  clipboard reset
'  clipboard set text value
	Debug_IsEqual(  83, value, Build$("a",$CrLf,"b"), "GetInstanceVariables" )

	'=================================================================
	pbsProjectClose()
	pbsProjectLoad( basePath + "TestProject\exportcommon.bas" )
	pbsProjectDeclareScan()
	i = pbsProjectDeclareFindName( 0, "cTest", %DeclarationTypes.eClass )
	value = pbsProjectDeclareGetNames( %DeclarationTypes.eInterface )
'  Clipboard Reset
'  Clipboard Set Text value
	Debug_IsEqual(  84, value, Build$("iTest",$CrLf,"iTest2", $CrLf, "iTest3"), "GetNames" )

	'=================================================================
	pbsProjectClose()
	pbsProjectLoad( basePath + "TestProject\exportcommon.bas" )
	pbsProjectDeclareScan()
	i = pbsProjectDeclareFindName( 0, "cTest", %DeclarationTypes.eClass )
	value = pbsProjectDeclareGetSignature( i )
	Debug_IsEqual(  85, value, "Class cTest Guid$(""{68EDF2C9-A459-4B4C-B9A4-B44379CB7E9D}"") Common", "GetSignature" )

	'=================================================================
	pbsProjectClose()
	pbsProjectLoad( basePath + "TestProject\exportcommon.bas" )
	pbsProjectDeclareScan()
	i = pbsProjectDeclareFindName( 0, "iTest", %DeclarationTypes.eInterface )
	pbsProjectDeclareGetItem( i, decl )
	Debug_IsEqual(  86, decl.tFileNumber, 0, "FileNumber" )
	Debug_IsEqual(  87, decl.tLineNumber, 91, "LineNumber" )
	Debug_IsEqual(  88, decl.tTokenNumber, 0, "TokenNumber" )
	Debug_IsEqual(  89, decl.tNameIndex, 26, "NameIndex" )
	Debug_IsEqual(  90, decl.tDeclType, 9, "DeclType" )
	Debug_IsEqual(  91, decl.tParent, 29, "Parent" )
	value = pbsProjectDeclareGetName( decl.tNameIndex )
	Debug_IsEqual(  92, value, "iTest", "GetName" )
	value = pbsProjectDeclareGetDeclarationName( decl.tDeclType )
	Debug_IsEqual(  93, value, "Interface", "GetName" )

	pbsProjectDeclareGetItem( decl.tParent, decl )
	Debug_IsEqual(  94, decl.tNameIndex, 25, "NameIndex" )
	value = pbsProjectDeclareGetName( decl.tNameIndex )
	Debug_IsEqual(  95, value, "cTest", "GetName" )

	'=================================================================
	pbsProjectClose()
	pbsProjectLoad( basePath + "TestProject\exportcommon.bas" )
	pbsProjectDeclareScan()
	value = pbsProjectGetInterfaceClasses( "iTest" )
	Debug_IsEqual(  96, value, Build$("cTest", $CrLf, "cTest2"), "InterfaceClasses" )

	i = pbsProjectDeclareFindName( 0, "iTest", %DeclarationTypes.eInterface )
	value = pbsProjectGetInterfaceRoutines( i )
	Debug_IsEqual(  97, value, Build$("Work", $CrLf, "Test"), "InterfaceRoutines" )

	value = pbsProjectGetInterfaceStub( i )
'  clipboard reset
'  clipboard set text value
	pbsSnippetNew("test")
	pbsSnippetLoad( basePath + "testProject\exportcommonInterfaceStub.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual(  98, value, value2, "GetInterfaceStub" )
End Sub
